void SetupPixelFormat(HDC hDC)
{
	int nPixelFormat;				 

	static PIXELFORMATDESCRIPTOR pfd = {
		sizeof(PIXELFORMATDESCRIPTOR), 
		1,						 
		PFD_DRAW_TO_WINDOW |		 
		PFD_SUPPORT_OPENGL |		 
		PFD_DOUBLEBUFFER,			 
		PFD_TYPE_RGBA,				 
		32,						 
		0, 0, 0, 0, 0, 0,			 
		0,						 
		0,						 
		0,						 
		0, 0, 0, 0,				
		16,						
		16,						
		0,						
		PFD_MAIN_PLANE,			
		0,						
		0, 0, 0 };				

	nPixelFormat = ChoosePixelFormat(hDC, &pfd);

	SetPixelFormat(hDC, nPixelFormat, &pfd);  
}