#include <shellapi.h>

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	WNDCLASSEX windowClass;	
	HWND	   hwnd;			
	MSG		   msg;	
	bool	   done;		
	DWORD	   dwExStyle;
	DWORD	   dwStyle;
	RECT	   windowRect;


	width = 1024;
	height = 768;
	int bits = 16;



	windowRect.left=(long)0;					
	windowRect.right=(long)width;				
	windowRect.top=(long)0;						
	windowRect.bottom=(long)height;			
	windowClass.cbSize			= sizeof(WNDCLASSEX);
	windowClass.style			= CS_HREDRAW | CS_VREDRAW;
	windowClass.lpfnWndProc		= WndProc;
	windowClass.cbClsExtra		= 0;
	windowClass.cbWndExtra		= 0;
	windowClass.hInstance		= hInstance;
	windowClass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);	
	windowClass.hCursor			= LoadCursor(NULL, IDC_ARROW);	
	windowClass.hbrBackground	= NULL;					
	windowClass.lpszMenuName	= NULL;							
	windowClass.lpszClassName	= "MyClass";
	windowClass.hIconSm			= LoadIcon(NULL, IDI_WINLOGO);


	if (!RegisterClassEx(&windowClass))
		return 0;

	if (fullScreen)							
	{
		DEVMODE dmScreenSettings;					
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));
		dmScreenSettings.dmSize = sizeof(dmScreenSettings);	
		dmScreenSettings.dmPelsWidth = width;		
		dmScreenSettings.dmPelsHeight = height;		
		dmScreenSettings.dmBitsPerPel = bits;	
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

	
		if (ChangeDisplaySettings(&dmScreenSettings, CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL)
		{
		
			MessageBox(NULL, "Display mode failed", NULL, MB_OK);
			fullScreen=FALSE;	
		}
	}

	if (fullScreen)						
	{
		dwExStyle=WS_EX_APPWINDOW;			
		dwStyle=WS_POPUP;						
		ShowCursor(FALSE);					
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;	
		dwStyle=WS_OVERLAPPEDWINDOW;					
	}

	AdjustWindowRectEx(&windowRect, dwStyle, FALSE, dwExStyle);		


	hwnd = CreateWindowEx(NULL,								
						  "MyClass",						
						  "SlipStream",
						  dwStyle | WS_CLIPCHILDREN |
						  WS_CLIPSIBLINGS,
						  0, 0,						
						  windowRect.right - windowRect.left,
						  windowRect.bottom - windowRect.top,	
						  NULL,						
						  NULL,						
						  hInstance,					
						  NULL);						
	if (!hwnd)
		return 0;



 



	ShowWindow(hwnd, SW_SHOW);			
	UpdateWindow(hwnd);					

	done = false;
	Initialize();
	while (!done)
	{
		PeekMessage(&msg, hwnd, NULL, NULL, PM_REMOVE);

		if (msg.message == WM_QUIT)		
		{
			done = true;				
		}
		else
		{
			
			if (keyPressed['A'])
			{
				player1.state = push;
			
			 
			}
	 			if (keyPressed['D'])
			{
				player1.state = pull;
		 
			 
			}

			if (keyPressed[VK_LEFT])
			{
				if(player1.dead == false && player1.wlock == false)
				{

				
				 player1.spin  += player1.spinrat*timeE;
				 player1.dir.z = float(cos(player1.spin) - sin(player1.spin));
				 player1.dir.x = float(cos(player1.spin) + sin(player1.spin));
				 
				}
				else
				{
					if(player1.wlock == true)
					{
					player1.spin  += (player1.spinrat*timeE)/3;
					 player1.dir.z = float(cos(player1.spin) - sin(player1.spin));
					 player1.dir.x = float(cos(player1.spin) + sin(player1.spin));
					}
					player1.wlock = false;

				}
		 
		 
			}
			if (keyPressed['P'])
			{
				if(choice == 11)
				{
								 choice = 11;
			   		if(player1.dead == true)
						{
							whattrack++;
							if(whattrack > 4)
							{
								whattrack = 1;
							}
						}
 
		 	 	numcar = 0;

						Init2();
						
						player1.restart();
						cpu[0].restart();
						cpu[1].restart();
						cpu[2].restart();
						cpu[3].restart();

			player1.color.x = 1;
			player1.color.y = 0;
			player1.color.z = 0;
			player1.engine = 2;
			player1.maxspd = 1.4f ;
			player1.bota  = 1.4f;
			whattrack = 1;
			money = 3000;
				 
					
				}

			}
			if (keyPressed[VK_RIGHT])
			{


				if(player1.dead == false && player1.wlock == false)
				{
			 		
				 player1.spin -= player1.spinrat*timeE;
				 player1.dir.z = float(cos(player1.spin) - sin(player1.spin));
				 player1.dir.x = float(cos(player1.spin) + sin(player1.spin));
				 
				}
				else
				{	
					if(player1.wlock == true)
					{
					player1.spin  += (player1.spinrat*timeE)/3;
					 player1.dir.z = float(cos(player1.spin) - sin(player1.spin));
					 player1.dir.x = float(cos(player1.spin) + sin(player1.spin));
					}
					player1.wlock = false;
				}
		 
			}
			
			if (keyPressed['Q'])
			{



		 if(choice != 10)
		 {
			 sav();
		 }
			 choice = 11;
			 
		 
			   		if(player1.dead == true)
						{
							whattrack++;
							if(whattrack > 4)
							{
								whattrack = 1;
							}
						}
		 
		 	 	numcar = 0;

					
						
						player1.restart();
						cpu[0].restart();
						cpu[1].restart();
						cpu[2].restart();
						cpu[3].restart();
							Init2();
	 	if(ifstream save("save.car",ios::nocreate))
	{
	save >> player1.color.x;
	save >> player1.color.y ;
	save >> player1.color.z ;
	save >> player1.engine ;
	save >> player1.maxspd ;
	save >> player1.bota  ;
	save >> money;
 
	}

		
			//	cpu1 << player1.pos.x << "\n";
			//	cpu1 << player1.pos.z << "\n";
				
				
			}

			if(keyPressed['Z'])
			{
				player1.boast = true;
			}
	
			if (keyPressed[VK_DOWN])
			{
				if(choice != 11)
				{
				if(choicef < 0)
				{
				 choice++;
				 if(choice > 4)
					 choice = 1;
				 choicef = 0.1f;
				}
				}


				if(choice == 11)
				{
					if(menupf < 0)
					{
						menup ++;
						if(menup > 1) menup = 0;

					}
					menupf = 0.1f;
					

				}
			}
		
			if (keyPressed[VK_UP])
			{
				if(choice != 11)
				{

				if(choicef < 0)
				{
				 choice--;
				 if(choice < 1)
					 choice = 4;
				 choicef = 0.1f;
				}
				
				}
				if(choice == 11)
				{
					if(menupf < 0)
					{
						menup--;
						if(menup < 0) menup = 1;

					}
					menupf = 0.1f;
					

				}
			}

			if (keyPressed[VK_LEFT])
			{
				if(choice == 1)
				{
					if(choice2f < 0)
					{
					 choice2--;
					 choice2--;
					 choice2--;
					 if(choice2 < 1)
						 choice2 = 765;
						 choice2f = 0.001f;
					}
				}
				if(choice == 2)
				{
					if(choice3f < 0)
					{
					 choice3--;
					 if(choice3 < 1)
						 choice3 = 5;
						 choice3f = 0.1f;
					}
				}
				if(choice == 3)
				{
					if(choice4f < 0)
					{
					 choice4--;
					 if(choice4 < 1)
						 choice4 = 5;
						 choice4f = 0.1f;
					}
				}
				if(choice == 4)
				{
					if(choice5f < 0)
					{
					 choice5--;
					 if(choice5 < 1)
						 choice5 = 5;
						 choice5f = 0.1f;
					}
				}
			}
			if (keyPressed[VK_RIGHT])
			{
				if(choice == 1)
				{
				if(choice2f < 0)
				{
				 choice2++;
				 choice2++;
				 choice2++;
				 if(choice2 > 765)
					 choice2 = 0;
				 choice2f = 0.001f;
				}
				}
				if(choice == 2)
				{
					if(choice3f < 0)
					{
					 choice3++;
					 if(choice3 > 5)
						 choice3 = 1;
						 choice3f = 0.1f;
					}
				}
				if(choice == 3)
				{
					if(choice4f < 0)
					{
					 choice4++;
					 if(choice4 > 5)
						 choice4 = 1;
						 choice4f = 0.1f;
					}
				}
				
				if(choice == 4)
				{
					if(choice5f < 0)
					{
					 choice5++;
					 if(choice5 > 5)
						 choice5 = 1;
						 choice5f = 0.1f;
					}
				}
			}
	
			if(keyPressed[VK_RETURN])

			{
				
					
 
			if(choice == 11)
			{
				if(menup == 0)
				choice = 1;
			}
			if(choice == 11)
			{
				if(menup == 1)
				choice = 10;
			}
			if(moneyf < 0)
			{
				if(choice == 2)
				{

					money -= int(choice3*1000);
					
					if(money >= 0)
					{
					


					if(choice3 == 1){player1.engine = 1.5f; player1.maxspd = 1.5f;}
					if(choice3 == 2){ player1.engine = 1.6f; player1.maxspd = 1.8f;}
					if(choice3 == 3){ player1.engine = 2.0f; player1.maxspd = 1.9f;}
					if(choice3 == 4){ player1.engine = 3.4f; player1.maxspd = 2.4f;}
					if(choice3 == 5){ player1.engine = 5.4f; player1.maxspd = 3.3f;}
					}
					if(money < 0) {money += int(choice3*1000);}
			 

				}
				
				if(choice == 3)
				{

					money -= int(choice4*1000);
					
					if(money >= 0)
					{
						if(choice4 == 1) { player1.bota = 1.6f;}
						if(choice4 == 2) { player1.bota = 1.8f;}
						if(choice4 == 3) { player1.bota = 1.9f;}
						if(choice4 == 4) { player1.bota = 2.2f;}
						if(choice4 == 5) { player1.bota = 2.8f;}
						
						
					}
					if(money < 0) {money += int(choice4*1000);}

				}

				if(choice == 4)
				{
					money -= int(choice5*1000);
					
					if(money >= 0)
					{
					if(choice5 == 1) {player1.spinrat = 1.5f;}
					if(choice5 == 2) {player1.spinrat = 1.6f;}
					if(choice5 == 3) {player1.spinrat = 1.7f;}
					if(choice5 == 4) {player1.spinrat = 3.0f;}
					if(choice5 == 5) {player1.spinrat = 4.5f;}
					}
					if(money < 0) {money += int(choice5*1000);}
				}
				moneyf = 0.5;
			}
			}
			if (keyPressed[VK_ESCAPE])
			{
				sav();

				done = true;
			

			}
			else
			{
				Render();			 

				TranslateMessage(&msg); 
				DispatchMessage(&msg);
			}
		}
	}

 
 
	delete timer;
 
	CoUninitialize();

	if (fullScreen)
	{
		ChangeDisplaySettings(NULL,0);		 
		ShowCursor(TRUE);				 
	}

	return msg.wParam;
}
