 

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HGLRC hRC;				
	static HDC hDC;				
	int width, height;				

	switch(message)
	{
		case WM_CREATE:				

			hDC = GetDC(hwnd);		
			g_HDC = hDC;
			SetupPixelFormat(hDC);		
			hRC = wglCreateContext(hDC);
			wglMakeCurrent(hDC, hRC);
			return 0;
			break;

		case WM_CLOSE:				

	
			wglMakeCurrent(hDC, NULL);
			wglDeleteContext(hRC);

	
			PostQuitMessage(0);

			return 0;
			break;

		case WM_SIZE:
			height = HIWORD(lParam);	
			width = LOWORD(lParam);

			if (height==0)				
			{
				height=1;					
			}

			glViewport(0, 0, width, height);	
			glMatrixMode(GL_PROJECTION);	
			glLoadIdentity();				

		
			gluPerspective(54.0f,(GLfloat)width/(GLfloat)height,1.0f,1000.0f);

			glMatrixMode(GL_MODELVIEW);	
			glLoadIdentity();				

			return 0;
			break;

		case WM_KEYDOWN:				
			keyPressed[wParam] = true;
			return 0;
			break;

		case WM_KEYUP:
			keyPressed[wParam] = false;
			return 0;
			break;
			
	
		
		default:
			break;
	}

	return (DefWindowProc(hwnd, message, wParam, lParam));
}