#define WIN32_LEAN_AND_MEAN	 
#define BITMAP_ID 0x4D42		 
#define PI		3.14159


 
int width;
int height;
 float timeE;
 float scale;
////// Includes
#include <windows.h>			 
#include <dmusicc.h>		 
#include <dmusici.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <gl/gl.h>			 
#include <gl/glu.h>				 
#include "HiResTimer.h"
#include "vector.h"
#include "Plane.h"
 CPlane rfloor;
 float setlong = 0;
 float winlong = 0;
 int menup = 0;
 float menupf;
 GLUquadricObj *quad = NULL;
CVector x, v1x,v1y,v2x,v2y,u1x,u2x,u1y,u2y;

CVector fallback;
BITMAPFILEHEADER	bitmapFileHeader;
BITMAPINFOHEADER	mapInfoHeader;
BITMAPINFOHEADER	mapInfoHeader2;

int money = 3000;
float gamestart;
int lstop;
#include "md2.h"
#include <fstream.h>
bool stopreading = false;

ifstream maincar("save.car");
ifstream camera("camerax.txt");
ifstream camera1("cameray.txt");
int numcar;
unsigned char*		map; 
unsigned char*		lifebar;
unsigned char*		backround;
int choice = 11;
float choicef;
float choice2 = 250;
float choice2f;
float choice3 = 1;
float choice3f;
float choice4 = 1;
float choice4f;
float moneyf;
float spinf;


float choice5 = 1;
float choice5f;
double distance(CVector x1, CVector x2)
{
return sqrt(((x1.x - x2.x)*(x1.x - x2.x))+
		((x1.z - x2.z)*(x1.z - x2.z)));
}
modelData_t *myModel;
modelData_t *myModel2;
float interValue = 0.0f;
void FreeModel(modelData_t *model)
{
	if (model->triIndex != NULL)
		free(model->triIndex);
	if (model->pointList != NULL)
		free(model->pointList);
	if (model->st != NULL)
		free(model->st);
	if (model != NULL)
		free(model);
}
unsigned char *LoadBMP(char *filename, BITMAPINFOHEADER *bitmapInfoHeader)
{
	FILE *filePtr;						 
	BITMAPFILEHEADER	bitmapFileHeader;		 
	unsigned char		*bitmapImage;		 
	unsigned int		imageIdx = 0;	 
	unsigned char		tempRGB;			 

 
	filePtr = fopen(filename, "rb");
	if (filePtr == NULL)
		return NULL;
 
	fread(&bitmapFileHeader, sizeof(BITMAPFILEHEADER), 1, filePtr);
	
 
	if (bitmapFileHeader.bfType != BITMAP_ID)
	{
		fclose(filePtr);
		return NULL;
	}

 
	fread(bitmapInfoHeader, sizeof(BITMAPINFOHEADER), 1, filePtr);

 
	fseek(filePtr, bitmapFileHeader.bfOffBits, SEEK_SET);

 
	bitmapImage = (unsigned char*)malloc(bitmapInfoHeader->biSizeImage);

 
	if (!bitmapImage)
	{
		free(bitmapImage);
		fclose(filePtr);
		return NULL;
	}

 
	fread(bitmapImage, 1, bitmapInfoHeader->biSizeImage, filePtr);

	 
	if (bitmapImage == NULL)
	{
		fclose(filePtr);
		return NULL;
	}

	
	for (imageIdx = 0; imageIdx < bitmapInfoHeader->biSizeImage; imageIdx+=3)
	{
		tempRGB = bitmapImage[imageIdx];
		bitmapImage[imageIdx] = bitmapImage[imageIdx + 2];
		bitmapImage[imageIdx + 2] = tempRGB;
	}

	
	fclose(filePtr);
	return bitmapImage;
}


texture_t *LoadBMPTexture(char *filename)
{
	BITMAPINFOHEADER texInfo;	 
	texture_t *thisTexture;		 

 
	thisTexture = (texture_t*)malloc(sizeof(texture_t));
	if (thisTexture == NULL)
		return NULL;

 
	thisTexture->data = LoadBMP(filename, &texInfo);
	if (thisTexture->data == NULL)
	{
		free(thisTexture);
		return NULL;
	}
 
	thisTexture->width = texInfo.biWidth;
	thisTexture->height = texInfo.biHeight;
	thisTexture->palette = NULL;
	thisTexture->scaledHeight = 0;
	thisTexture->scaledWidth = 0;
	thisTexture->textureType = BMP;

	return thisTexture;
}

 
texture_t *LoadTexture(char *filename)
{

	
	texture_t *thisTexture;
	char *extStr;

 
	extStr = strchr(filename, '.');
	extStr++;
 
	if ((strcmp(extStr, "BMP") == 0) || (strcmp(extStr, "bmp") == 0))
		thisTexture = LoadBMPTexture(filename);
 
 
	return thisTexture;
}

 
void SetupMD2Texture(texture_t *thisTexture)
{
 
	glGenTextures(1, &thisTexture->texID);

	glBindTexture(GL_TEXTURE_2D, thisTexture->texID);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

	switch (thisTexture->textureType)
	{
		case BMP:
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, thisTexture->width, thisTexture->height, 
							  GL_RGB, GL_UNSIGNED_BYTE, thisTexture->data);
			break;
		case PCX:
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, thisTexture->width, thisTexture->height,
							  GL_RGBA, GL_UNSIGNED_BYTE, thisTexture->data);
		case TGA:
			break;
		default:
			break;
	}
}

 
modelData_t *LoadMD2Model(char *filename, char *textureName)
{
	FILE *filePtr;						 
	int fileLen;					 
    char *buffer;					 
		
	modelData_t *model;				 
	modelHeader_t *modelHeader;			 
	texture_t *md2Texture;			 

	stIndex_t *stPtr;				 
    frame_t *frame;					 
	vector_t *pointListPtr;			 
    mesh_t *triIndex, *bufIndexPtr;	 
    int i, j;						 

 
	filePtr = fopen(filename, "rb");
	if (filePtr == NULL)
		return NULL;

 
    fseek(filePtr, 0, SEEK_END);
    fileLen = ftell(filePtr);
    fseek(filePtr, 0, SEEK_SET);
	
 
    buffer = (char*)malloc(fileLen + 1);
    fread(buffer, sizeof(char), fileLen, filePtr);

 
    modelHeader = (modelHeader_t*)buffer;

 
   	model = (modelData_t*)malloc(sizeof(modelData_t));
	if (model == NULL)
		return NULL;

 
    model->pointList = (vector_t*)malloc(sizeof(vector_t)*modelHeader->numXYZ * modelHeader->numFrames);

 
    model->numPoints = modelHeader->numXYZ;
    model->numFrames = modelHeader->numFrames;
	model->frameSize = modelHeader->framesize;

    
    for(j = 0; j < modelHeader->numFrames; j++)
    {
    
       frame = (frame_t*)&buffer[modelHeader->offsetFrames + modelHeader->framesize * j];

	    
       pointListPtr = (vector_t*)&model->pointList[modelHeader->numXYZ * j];
       for(i = 0; i < modelHeader->numXYZ; i++)
       {
          pointListPtr[i].point[0] = frame->scale[0] * frame->fp[i].v[0] + frame->translate[0];
          pointListPtr[i].point[1] = frame->scale[1] * frame->fp[i].v[1] + frame->translate[1];
          pointListPtr[i].point[2] = frame->scale[2] * frame->fp[i].v[2] + frame->translate[2];
       }
    }
			 
 
	md2Texture = LoadTexture(textureName);
	if (md2Texture != NULL)
	{
	 
		SetupMD2Texture(md2Texture);
		model->modelTex = md2Texture;
	}
	else
		return NULL;

 
    model->st = (texCoord_t*)malloc(sizeof(texCoord_t)*modelHeader->numST);
 
    model->numST = modelHeader->numST;

 
    stPtr = (stIndex_t*)&buffer[modelHeader->offsetST];

	 
    for (i = 0; i < modelHeader->numST; i++)
    {
		model->st[i].s = (float)stPtr[i].s / (float)md2Texture->width;
        model->st[i].t = (float)stPtr[i].t / (float)md2Texture->height;
    }
 
	triIndex = (mesh_t*)malloc(sizeof(mesh_t) * modelHeader->numTris);

 
	model->numTriangles = modelHeader->numTris;
	model->triIndex = triIndex;
	
 
	bufIndexPtr = (mesh_t*)&buffer[modelHeader->offsetTris];

	 
	for (j = 0; j < model->numFrames; j++)		
	{ 
		for(i = 0; i < modelHeader->numTris; i++)
		{
		   triIndex[i].meshIndex[0] = bufIndexPtr[i].meshIndex[0];
		   triIndex[i].meshIndex[1] = bufIndexPtr[i].meshIndex[1];
		   triIndex[i].meshIndex[2] = bufIndexPtr[i].meshIndex[2];
		   triIndex[i].stIndex[0] = bufIndexPtr[i].stIndex[0];
		   triIndex[i].stIndex[1] = bufIndexPtr[i].stIndex[1];
		   triIndex[i].stIndex[2] = bufIndexPtr[i].stIndex[2];
		}
	}

 
	fclose(filePtr);
    free(buffer);

	model->currentFrame = 0;
	model->nextFrame = 1;
	model->interpol = 0.0;

    return model;
}

 
void CalculateNormal( float *p1, float *p2, float *p3 )
{
   float a[3], b[3], result[3];
   float length;

   a[0] = p1[0] - p2[0];
   a[1] = p1[1] - p2[1];
   a[2] = p1[2] - p2[2];

   b[0] = p1[0] - p3[0];
   b[1] = p1[1] - p3[1];
   b[2] = p1[2] - p3[2];

   result[0] = a[1] * b[2] - b[1] * a[2];
   result[1] = b[0] * a[2] - a[0] * b[2];
   result[2] = a[0] * b[1] - b[0] * a[1];

   
   length = (float)sqrt(result[0]*result[0] + result[1]*result[1] + result[2]*result[2]);
 
   glNormal3f(result[0]/length, result[1]/length, result[2]/length);
}

 
void DisplayMD2(modelData_t *model, int frameNum)
{
	vector_t *pointList;
	int i;

   
    pointList = &model->pointList[model->numPoints * frameNum];
	
 
    glBegin(GL_TRIANGLES);
		for(i = 0; i < model->numTriangles; i++)
        {
			CalculateNormal(pointList[model->triIndex[i].meshIndex[0]].point,pointList[model->triIndex[i].meshIndex[2]].point, pointList[model->triIndex[i].meshIndex[1]].point);
			glVertex3fv(pointList[model->triIndex[i].meshIndex[0]].point);
            glVertex3fv(pointList[model->triIndex[i].meshIndex[2]].point);
            glVertex3fv(pointList[model->triIndex[i].meshIndex[1]].point);
        }
    glEnd();
}
 


void CleanUp()
{
 
	FreeModel(myModel);
	FreeModel(myModel2);
}

CHiResTimer *timer = NULL;
CHiResTimer *timer2 = NULL;

CPlane tar[30];

 
class wall
{
public:

	wall()
	{
		length = 42;
	}
 
	CVector point[4];
	CVector balls[250];
	int length;

	int xslide;
	int zslide;
	CVector slide;
	CVector normal;

	void draw()
	{
		glColor3f(1,1,0);
		glPushMatrix();
			glBegin(GL_QUADS);
				glNormal3f(normal.x,normal.y,normal.z);
				for(int h = 1;h < 5; h++)
				{					
					glVertex3f(point[h].x,point[h].y,point[h].z);
				}
			glEnd();
		glPopMatrix();
	}

};
	wall track[30];
enum move
{
	push,pull,stop

};
 
int whattrack;

CVector poso[10000];
 

CVector cam;
CVector dir;
CVector fcam;
texture_t *skyi;


float spin;
float cami;
 
HDC g_HDC;				 
bool fullScreen = true;		 
bool keyPressed[256];			 

float angle = 0.0f;
unsigned int listBase;			 
GLYPHMETRICSFLOAT gmf[256];	 
						 
 

 int oldplace;
float howlong;
float dcam;
 
float mouseX,mouseY;
float oldMouseX,oldMouseY;
 

 

GLuint land;
GLuint ring;
GLuint windline;
GLuint drawcar;
GLuint ball;
 	CVector v,b,c;
 
 
int numt;
#include "car.h"
car player1;

car cpu[20];
#include "wind.h"
wind trackwind;



engine firez[4];
#include "enginef.h"
#include "pixel.h"
#include "callback.h"
 
#include "text.h"
#include "initialize.h"
#include "particle.h"

#include "render.h"
#include "winmain.h"
