 
#define EPSILON  1
#define MODULUS(p) (sqrt(p.x*p.x + p.y*p.y + p.z*p.z))
#define TWOPI 6.283185307179586476925286766559			  
#define RTOD 57.2957795

double  CalcA(CVector q,CVector *p,int n)
{

   int i;
   double m1,m2;
   double anglesum=0,costheta;
   CVector p1,p2;

   for (i=1;i<n;i++) {

      p1 = p[i];
      p2 = p[(i+1)%5];

      m1 = MODULUS(p1);
      m2 = MODULUS(p2);
 
         costheta = (p1.x*p2.x + p1.y*p2.y + p1.z*p2.z) / (m1*m2);

      anglesum += acos(costheta);
	 

   }
   if((anglesum <= (TWOPI + EPSILON )) && (anglesum >= (TWOPI -  EPSILON)))
   {
	   return true;
 
   }
	else
	   return false;
 
}

