 #ifndef __TEXTURE_H
#define __TEXTURE_H

#include <stdio.h>
#include <iostream.h>
#include <windows.h>
#include <commctrl.h>
#include <windowsx.h>
#include <gl/gl.h>

enum texTypes_t
{
	PCX,
	BMP,
	TGA
};

typedef struct 
{
 
	texTypes_t textureType;

	int width;				 
	int height;				 
	long int scaledWidth;
	long int scaledHeight;

	unsigned int texID;		 
	unsigned char *data;	 
	unsigned char *palette;
} texture_t;

 
typedef struct
{
	unsigned char manufacturer;
	unsigned char version;
	unsigned char encoding;
	unsigned char bits;
	unsigned char xMin;
	unsigned char yMin;
	unsigned char xMax;
	unsigned char yMax;
	unsigned char *palette;
} PCXHEADER;

#endif